diff --git a/plugins/imfile/imfile.c b/plugins/imfile/imfile.c
index 285ef42bd0..5bdb463639 100644
--- a/plugins/imfile/imfile.c
+++ b/plugins/imfile/imfile.c
@@ -2041,6 +2041,34 @@ in_setupFileWatchDynamic(lstn_t *pLstn,
 done:	return;
 }
 
+/* Search for matching files using glob.
+ * Create Dynamic Watch for each found file
+ */
+static void
+in_setupFileWatchGlobSearch(lstn_t *pLstn)
+{
+	DBGPRINTF("in_setupFileWatchGlobSearch file '%s' has wildcard, doing initial "
+		  "expansion\n", pLstn->pszFileName);
+	glob_t files;
+	const int ret = glob((char*)pLstn->pszFileName,
+				GLOB_MARK|GLOB_NOSORT|GLOB_BRACE, NULL, &files);
+	if(ret == 0) {
+		for(unsigned i = 0 ; i < files.gl_pathc ; i++) {
+			uchar basen[MAXFNAME];
+			uchar *const file = (uchar*)files.gl_pathv[i];
+
+			if(file[strlen((char*)file)-1] == '/')
+				continue;/* we cannot process subdirs! */
+
+			getBasename(basen, file);
+			DBGPRINTF("in_setupFileWatchGlobSearch setup dynamic watch "
+				"for '%s : %s' \n", basen, file);
+			in_setupFileWatchDynamic(pLstn, basen, file);
+		}
+		globfree(&files);
+	}
+}
+
 /* Setup a new file watch for static (configured) files.
  * Note: we need to try to read this file, as it may already contain data this
  * needs to be processed, and we won't get an event for that as notifications
@@ -2058,26 +2086,8 @@ in_setupFileWatchStatic(lstn_t *pLstn)
 	/* perform wildcard check on static files manually */
 	hasWildcard = containsGlobWildcard((char*)pLstn->pszFileName);
 	if(hasWildcard) {
-		DBGPRINTF("in_setupFileWatchStatic file '%s' has wildcard, doing initial "
-			  "expansion\n", pLstn->pszFileName);
-		glob_t files;
-		const int ret = glob((char*)pLstn->pszFileName,
-					GLOB_MARK|GLOB_NOSORT|GLOB_BRACE, NULL, &files);
-		if(ret == 0) {
-			for(unsigned i = 0 ; i < files.gl_pathc ; i++) {
-				uchar basen[MAXFNAME];
-				uchar *const file = (uchar*)files.gl_pathv[i];
-
-				if(file[strlen((char*)file)-1] == '/')
-					continue;/* we cannot process subdirs! */
-
-				getBasename(basen, file);
-				DBGPRINTF("in_setupFileWatchStatic setup dynamic watch "
-					"for '%s : %s' \n", basen, file);
-				in_setupFileWatchDynamic(pLstn, basen, file);
-			}
-			globfree(&files);
-		}
+		/* search for matching files */
+		in_setupFileWatchGlobSearch(pLstn);
 	} else {
 		/* Duplicate static object as well, otherwise the configobject
 		 * could be deleted later! */
@@ -2201,6 +2211,8 @@ in_handleDirEventDirCREATE(struct inotify_event *ev, const int dirIdx)
 {
 	char fulldn[MAXFNAME];
 	int newdiridx;
+	int iListIdx;
+	sbool hasWildcard;
 
 	/* Combine to Full Path first */
 	in_handleDirGetFullDir(fulldn, dirIdx, (char*)ev->name);
@@ -2213,6 +2225,22 @@ in_handleDirEventDirCREATE(struct inotify_event *ev, const int dirIdx)
 		dirsAdd((uchar*)fulldn, &newdiridx);
 		dirs[newdiridx].bDirType = DIR_DYNAMIC; /* Set to DYNAMIC directory! */
 		in_setupDirWatch(newdiridx);
+
+		/* Initial Scan for files of the new directory */
+
+		/* Loop through configured Listeners and scan for dynamic files */
+		for(iListIdx = 0; iListIdx < dirs[newdiridx].configured.currMax; iListIdx++) {
+			hasWildcard = (	dirs[dirIdx].hasWildcard ||
+					dirs[dirIdx].configured.listeners[iListIdx].pLstn->hasWildcard
+					? TRUE : FALSE);
+			if (hasWildcard == 1){
+				/* search for matching files */
+				in_setupFileWatchGlobSearch(dirs[dirIdx].configured.listeners[iListIdx].pLstn);
+			}
+
+		}
+
+
 	} else {
 		DBGPRINTF("dir '%s' already exists in dirs table (Idx %d)\n", fulldn, newdiridx);
 	}
@@ -2796,7 +2824,7 @@ fen_processEventFile(struct file_obj* fobjp, lstn_t *pLstn, int revents, int dir
 	RETiRet;
 }
 
-/* function not used yet, will be needed for wildcards later */
+/* Helper function to find matching files for listener */
 rsRetVal
 fen_DirSearchFiles(lstn_t *pLstn, int dirIdx)
 {
diff --git a/tests/imfile-wildcards-dirs-multi.sh b/tests/imfile-wildcards-dirs-multi.sh
index d2c4f13fd3..9c80d1b0ee 100755
--- a/tests/imfile-wildcards-dirs-multi.sh
+++ b/tests/imfile-wildcards-dirs-multi.sh
@@ -21,19 +21,21 @@ do
 	for i in `seq 1 $IMFILEINPUTFILES`;
 	do
 		mkdir rsyslog.input.dir$i
-		./msleep 50
+#		./msleep 25
 		mkdir rsyslog.input.dir$i/dir$i
-		./msleep 50
+#		./msleep 25
 		./inputfilegen -m 1 > rsyslog.input.dir$i/dir$i/file.logfile
-		./msleep 100
+#		./msleep 50
 	done
 	ls -d rsyslog.input.*
 
+	./msleep 250
+
 	# Delete all but first!
 	for i in `seq 1 $IMFILEINPUTFILES`;
 	do
 		rm -rf rsyslog.input.dir$i/dir$i/file.logfile
-		./msleep 100
+#		./msleep 50
 		rm -rf rsyslog.input.dir$i
 	done
 done
diff --git a/tests/imfile-wildcards-dirs-multi2.sh b/tests/imfile-wildcards-dirs-multi2.sh
index e42be1e135..30b7474261 100755
--- a/tests/imfile-wildcards-dirs-multi2.sh
+++ b/tests/imfile-wildcards-dirs-multi2.sh
@@ -28,19 +28,21 @@ do
 	do
 		echo "Make rsyslog.input.dir$i/dir$j/testdir"
 		mkdir rsyslog.input.dir$i/dir$j
-		./msleep 25
+#		./msleep 25
 		mkdir rsyslog.input.dir$i/dir$j/testdir
-		./msleep 25
+#		./msleep 25
 		./inputfilegen -m 1 > rsyslog.input.dir$i/dir$j/testdir/file.logfile
-		./msleep 50
+#		./msleep 50
 	done
 	ls -d rsyslog.input.*
 
+	./msleep 250
+
 	# Delete all but first!
 	for i in `seq 1 $IMFILEINPUTFILES`;
 	do
 		rm -rf rsyslog.input.dir$i/dir$j/testdir/file.logfile
-		./msleep 50
+#		./msleep 50
 		rm -rr rsyslog.input.dir$i/dir$j
 	done
 done
